package org.kaoriha.jspbp.helloworld;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.lang.Validate;
import org.kaoriha.jspbp.BeforeGettable;
import org.kaoriha.jspbp.Persistent;

import uk.ltd.getahead.dwr.WebContextFactory;

public class Ajax implements BeforeGettable, Persistent {
	private String a;
	private String b;
	private String c;
	private String persistentId;

	public Ajax getPersistentInstance(String persistentId) {
		Validate.notNull(persistentId);
		HttpSession session = WebContextFactory.get().getSession();
		Object p = session.getAttribute(persistentId);
		if (p == null) {
			Ajax a = new Ajax();
			a.setPersistentId(persistentId);
			session.setAttribute(persistentId, a);
			return a;
		}
		return (Ajax) p;
	}

	private void calc() {
		try {
			int a = Integer.parseInt(getA());
			int b = Integer.parseInt(getB());
			setC(Integer.toString(a + b));
		} catch (NumberFormatException e) {
			setC("NaN");
		}
	}

	public Ajax calcRemote(Ajax remote) {
		Validate.notNull(remote);
		Validate.notNull(remote.persistentId);
		HttpSession session = WebContextFactory.get().getSession();
		remote.calc();
		session.setAttribute(remote.persistentId, remote);
		return remote;
	}

	public void beforeGet(HttpServletRequest request,
			HttpServletResponse response) throws IOException, ServletException {
	}

	public String getA() {
		return a;
	}

	public void setA(String a) {
		this.a = a;
	}

	public String getB() {
		return b;
	}

	public void setB(String b) {
		this.b = b;
	}

	public String getC() {
		return c;
	}

	public void setC(String c) {
		this.c = c;
	}

	public String getPersistentId() {
		return persistentId;
	}

	public void setPersistentId(String persistentId) {
		this.persistentId = persistentId;
	}
}
