package org.kaoriha.jspbp.helloworld;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.kaoriha.jspbp.BeforeGettable;
import org.kaoriha.jspbp.BeforePostable;
import org.kaoriha.jspbp.Persistent;

public class ContPers2Form implements BeforeGettable, BeforePostable, Persistent {
	protected ContPers2Form.Continuation continuation;
	private String b;
	private String persistentId;
	private String continuationId;

	public void beforeGet(HttpServletRequest request, HttpServletResponse response)
			throws IOException, ServletException {
		if (continuation == null || continuation.a == null) {
			response.sendRedirect("contPers1Form.jsp");
			return;
		}
	}

	public void beforePost(HttpServletRequest request,
			HttpServletResponse response) throws IOException, ServletException {
		if (continuation == null) {
			response.sendRedirect("contPers1Form.jsp");
			return;
		}

		try {
			Integer.parseInt(getB());
		} catch (NumberFormatException e) {
			setB("");
			response.sendRedirect(request.getRequestURI());
			return;
		}
		
		continuation.setB(getB());
		response.sendRedirect("contPers3.jsp");
	}
	
	public static class Continuation {
		private String a;
		private String b;

		public String getA() {
			return a;
		}

		public void setA(String a) {
			this.a = a;
		}

		public String getB() {
			return b;
		}

		public void setB(String b) {
			this.b = b;
		}
	}

	public String getB() {
		return b;
	}

	public void setB(String b) {
		this.b = b;
	}

	public String getPersistentId() {
		return persistentId;
	}

	public void setPersistentId(String persistentId) {
		this.persistentId = persistentId;
	}

	public void setContinuation(ContPers2Form.Continuation continuation) {
		this.continuation = continuation;
	}

	public ContPers2Form.Continuation getContinuation() {
		return continuation;
	}

	public String getContinuationId() {
		return continuationId;
	}

	public void setContinuationId(String continuationId) {
		this.continuationId = continuationId;
	}
}
