package org.kaoriha.jspbp.helloworld;

import java.io.IOException;
import java.io.InputStream;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.codec.binary.Base64;
import org.apache.commons.fileupload.FileItem;
import org.apache.commons.lang.StringEscapeUtils;
import org.kaoriha.jspbp.BeforeGettable;
import org.kaoriha.jspbp.BeforePostable;

public class FileForm implements BeforeGettable, BeforePostable {
	private String a;
	private String b;
	private String c;
	private FileItem file;
	private String filename;
	private String fileContentType;
	private String filesize;
	private String fileContent;

	public void beforeGet(HttpServletRequest arg0, HttpServletResponse arg1)
			throws IOException, ServletException {
	}

	public void beforePost(HttpServletRequest request,
			HttpServletResponse response) throws IOException, ServletException {
		try {
			int a = Integer.parseInt(getA());
			int b = Integer.parseInt(getB());
			setC(Integer.toString(a + b));
		} catch (NumberFormatException e) {
			setC("NaN");
		}

		if (file == null || file.getName().length() == 0) {
			filename = null;
			fileContentType = null;
			filesize = null;
			fileContent = null;
		} else {
			filename = file.getName();
			fileContentType = file.getContentType();
			filesize = Long.toString(file.getSize());
			byte[] buffer = new byte[1024];
			int n;
			int offset = 0;
			InputStream is = file.getInputStream();
			while (true) {
				n = is.read(buffer, offset, buffer.length - offset);
				offset += n;
				if (n == -1 || offset == buffer.length) {
					break;
				}
			}
			is.close();
			byte[] buf2 = new byte[offset];
			System.arraycopy(buffer, 0, buf2, 0, offset);
			fileContent = StringEscapeUtils.escapeHtml(
					new String(Base64.encodeBase64(buf2, true))).replace("\n",
					"<br />\n");
		}
	}

	public String getA() {
		return a;
	}

	public void setA(String a) {
		this.a = a;
	}

	public String getB() {
		return b;
	}

	public void setB(String b) {
		this.b = b;
	}

	public String getC() {
		return c;
	}

	public void setC(String c) {
		this.c = c;
	}

	public void setFile(FileItem file) {
		this.file = file;
	}

	public FileItem getFile() {
		return file;
	}

	public String getFilename() {
		return filename;
	}

	public String getFileContentType() {
		return fileContentType;
	}

	public String getFilesize() {
		return filesize;
	}

	public String getFileContent() {
		return fileContent;
	}
}
