/**
 * 
 */
package org.kaoriha.jspbp.helloworld.renderer;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.kaoriha.jspbp.renderer.table.Data;
import org.kaoriha.jspbp.renderer.table.Query;
import org.kaoriha.jspbp.renderer.table.Sort;
import org.kaoriha.jspbp.renderer.table.Sorter;

public class DataSource implements
		org.kaoriha.jspbp.renderer.table.Source<Column, String> {
	static final List<Map<Column, String>> rawData = new ArrayList<Map<Column, String>>();

	static void add(String firstName, String middleName, String lastName,
			String span) {
		Map<Column, String> row = new HashMap<Column, String>();
		row.put(Column.FirstName, firstName);
		row.put(Column.MiddleName, middleName);
		row.put(Column.LastName, lastName);
		row.put(Column.Span, span);
		rawData.add(row);
	}

	static {
		add("George", "", "Washington", "(1789-1797)");
		add("John", "", "Adams", "(1797-1801)");
		add("Thomas", "", "Jefferson", "(1801-1809)");
		add("James", "", "Madison", "(1809-1817)");
		add("James", "", "Monroe", "(1817-1825)");
		add("John", "Quincy", "Adams", "(1825-1829)");
		add("Andrew", "", "Jackson", "(1829-1837)");
		add("Martin", "Van", "Buren", "(1837-1841)");
		add("William", "Henry", "Harrison", "(1841)");
		add("John", "", "Tyler", "(1841-1845)");
		add("James", "K.", "Polk", "(1845-1849)");
		add("Zachary", "", "Taylor", "(1849-1850)");
		add("Millard", "", "Fillmore", "(1850-1853)");
		add("Franklin", "", "Pierce", "(1853-1857)");
		add("James", "", "Buchanan", "(1857-1861)");
		add("Abraham", "", "Lincoln", "(1861-1865)");
		add("Andrew", "", "Johnson", "(1865-1869)");
		add("Ulysses", "S.", "Grant", "(1869-1877)");
		add("Rutherford", "B.", "Hayes", "(1877-1881)");
		add("James", "A.", "Garfield", "(1881)");
		add("Chester", "", "Arthur", "(1881-1885)");
		add("Grover", "", "Cleveland", "(1885-1889)");
		add("Benjamin", "", "Harrison", "(1889-1893)");
		add("Grover", "", "Cleveland", "(1893-1897)");
		add("William", "", "McKinley", "(1897-1901)");
		add("Theodore", "", "Roosevelt", "(1901-1909)");
		add("William", "Howard", "Taft", "(1909-1913)");
		add("Woodrow", "", "Wilson", "(1913-1921)");
		add("Warren", "G.", "Harding", "(1921-1923)");
		add("Calvin", "", "Coolidge", "(1923-1929)");
		add("Herbert", "", "Hoover", "(1929-1933)");
		add("Franklin", "D.", "Roosevelt", "(1933-1945)");
		add("Harry", "S", "Truman", "(1945-1953)");
		add("Dwight", "D.", "Eisenhower", "(1953-1961)");
		add("John", "F.", "Kennedy", "(1961-1963)");
		add("Lyndon", "B.", "Johnson", "(1963-1969)");
		add("Richard", "", "Nixon", "(1969-1974)");
		add("Gerald", "", "Ford", "(1974-1977)");
		add("Jimmy", "", "Carter", "(1977-1981)");
		add("Ronald", "", "Reagan", "(1981-1989)");
		add("George", "", "Bush", "(1989-1993)");
		add("Bill", "", "Clinton", "(1993-2001)");
		add("George", "W.", "Bush", "(2001-)");
	}

	static final Map<Column, String> header = new HashMap<Column, String>();

	static {
		header.put(Column.FirstName, "First Name");
		header.put(Column.MiddleName, "Middle Name");
		header.put(Column.LastName, "Last Name");
		header.put(Column.Span, "Span");
	}

	public Data<Column, String> getData(Query<Column> query) {
		List<Map<Column, String>> data = new ArrayList<Map<Column, String>>(
				rawData);
		for (Sort<Column> s : query.getSortList()) {
			Collections.sort(data, new Sorter<Column, String>(s));
		}

		int fi = Math.min(query.getOffset(), data.size());
		int ti = Math.min(query.getOffset() + query.getSize(), data.size());
		return new Data<Column, String>(query, "US Presidents", data.subList(
				fi, ti), header, null, Arrays.asList(Column.FirstName,
				Column.MiddleName, Column.LastName, Column.Span), data.size());
	}

	public Column valueOfEnum(String name) {
		return Column.valueOf(name);
	}
}